unit TreeGrid_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, Buttons, ComCtrls, ExtCtrls, BIN;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    tv: TTreeView;
    ToolBar: TPanel;
    data: TStringGrid;
    save_btn: TSpeedButton;
    SaveDialog1: TSaveDialog;
    load_btn: TSpeedButton;
    OpenDialog1: TOpenDialog;
    additem_btn: TSpeedButton;
    addsub_btn: TSpeedButton;
    delitem_btn: TSpeedButton;
    insrow_btn: TSpeedButton;
    delrow_btn: TSpeedButton;
    inscol_btn: TSpeedButton;
    delcol_btn: TSpeedButton;
    procedure save_btnClick(Sender: TObject);
    procedure load_btnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure tvClick(Sender: TObject);
    procedure additem_btnClick(Sender: TObject);
    procedure addsub_btnClick(Sender: TObject);
    procedure delitem_btnClick(Sender: TObject);
    procedure insrow_btnClick(Sender: TObject);
    procedure delrow_btnClick(Sender: TObject);
    procedure inscol_btnClick(Sender: TObject);
    procedure delcol_btnClick(Sender: TObject);
    procedure dataKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Splitter1Moved(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    FPrevious: TTreeNode;
    procedure TextToGrid(ANode:TTreeNode);
    procedure GridToText(ANode:TTreeNode);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//HUWTSD I/O {
procedure SaveToTSDFile(var FromTreeView:TTreeView; AFileName:TFileName);
var TreeStream,Buffer:TMemoryStream;
    size,i,j:LongInt;
begin
  TreeStream:=TMemoryStream.Create;
  Buffer:=TMemoryStream.Create;
  try
    FromTreeView.SaveToStream(TreeStream);
    size:=TreeStream.Size;
    Buffer.Write(size,SizeOf(size));
    Buffer.CopyFrom(TreeStream,0);
    for i:=0 to FromTreeView.Items.Count-1 do
      begin
        if FromTreeView.Items[i].Data<>nil then size:=Length(String(FromTreeView.Items[i].Data^))
        else size:=0;
        Buffer.Write(size,SizeOf(size));
        if size>0 then
          begin
            //n@ӭӦrgJ~???
            for j:=1 to Length(String(FromTreeView.Items[i].Data^)) do
              Buffer.Write(String(FromTreeView.Items[i].Data^)[j],1);
          end;
      end;
    Buffer.SaveToFile(AFileName);
  finally
    Buffer.Free;
    TreeStream.Free;
  end;
end;

procedure LoadFromTSDFile(AFileName:TFileName; var ToTreeView:TTreeView);
var TreeStream,Buffer:TMemoryStream;
    size,i,j:LongInt;
    p:^string;
    a:char;
begin
  TreeStream:=TMemoryStream.Create;
  Buffer:=TMemoryStream.Create;
  try
    Buffer.LoadFromFile(AFileName);
    Buffer.Read(size,SizeOf(size));
    TreeStream.CopyFrom(Buffer,size);
    TreeStream.Position:=0;
    ToTreeView.LoadFromStream(TreeStream);
    for i:=0 to ToTreeView.Items.Count-1 do
      begin
        Buffer.Read(size,SizeOf(size));
        New(p);
        ToTreeView.Items[i].Data:=p;
        for j:=1 to size do  //n@ӭӦrŪX~???
          begin
            Buffer.Read(a,1);
            String(ToTreeView.Items[i].Data^):=String(ToTreeView.Items[i].Data^)+a;
          end;
      end;
  finally
    Buffer.Free;
    TreeStream.Free;
  end;
end;
//End WTSD I/O {

procedure TForm1.TextToGrid(ANode:TTreeNode);
var i,j:integer;
    ss:TStringList;
    s:string;
begin
  ss:=TStringList.Create;
  try
    ss.Text:=String(ANode.Data^);
    data.RowCount:=ss.Count;
    data.ColCount:=GetStrCount(ss[0],' ');
    for i:=0 to data.RowCount-1 do
      for j:=0 to data.ColCount-1 do
        begin
          s:=GetAStr(ss[i],j+1,' ');
          if s='~' then s:='';
          data.Cells[j,i]:=s;
        end;
  finally
    ss.Free;
  end;
end;

procedure TForm1.GridToText(ANode:TTreeNode);
var i,j:integer;
    s:string;
begin
  String(ANode.Data^):='';
  for i:=0 to data.RowCount-1 do
    begin
      s:='';
      for j:=0 to data.ColCount-1 do
        if data.Cells[j,i]='' then s:=s+'~ ' else s:=s+data.Cells[j,i]+' ';
      s[Length(s)]:=#13;
      String(ANode.Data^):=String(ANode.Data^)+s;
    end;
end;


procedure TForm1.save_btnClick(Sender: TObject);
begin
  if SaveDialog1.Execute then
    begin
      if FPrevious<>nil then GridToText(FPrevious);
      SaveToTSDFile(tv,SaveDialog1.FileName);
    end;
end;

procedure TForm1.load_btnClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
    begin
      LoadFromTSDFile(OpenDialog1.FileName,tv);
      tv.Selected:=tv.Items[0];
      TextToGrid(tv.Selected);
    end;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  FPrevious:=nil;
end;

procedure TForm1.tvClick(Sender: TObject);
begin
  if tv.Selected<>nil then
    begin
      if FPrevious<>nil then GridToText(FPrevious);
      FPrevious:=tv.Selected;
      TextToGrid(tv.Selected);
    end;
end;

procedure TForm1.additem_btnClick(Sender: TObject);
var p:^string;
begin
  New(p);
  p^:='~ ~ ~ ~ ~'+#13+'~'+#13+'~'+#13+'~'+#13+'~';
  tv.Selected:=tv.Items.AddObject(tv.Selected,'',p);
  tvClick(self);
  tv.Selected.EditText;
end;

procedure TForm1.addsub_btnClick(Sender: TObject);
var p:^string;
begin
  New(p);
  p^:='~ ~ ~ ~ ~'+#13+'~'+#13+'~'+#13+'~'+#13+'~';
  tv.Selected:=tv.Items.AddChildObject(tv.Selected,'',p);
  tvClick(self);
  tv.Selected.EditText;
end;

procedure TForm1.delitem_btnClick(Sender: TObject);
 procedure DeleteItem(ANode:TTreeNode);
 begin
   if ANode.Data<>nil then
     begin
       String(ANode.Data^):='';
       Dispose(ANode.Data);
     end;
   if ANode.HasChildren then
     while ANode.GetLastChild<>nil do
       DeleteItem(ANode.GetLastChild);
   ANode.Delete;
 end;
begin
  if tv.Selected<>nil then
    begin
      DeleteItem(tv.Selected);
      FPrevious:=nil;
    end;
end;

procedure TForm1.insrow_btnClick(Sender: TObject);
var i:integer;
begin
  data.RowCount:=data.RowCount+1;
  for i:=data.RowCount-1 downto data.Row+1 do
    data.Rows[i].CommaText:=data.Rows[i-1].CommaText;
  data.Rows[data.Row].CommaText:='';
end;

procedure TForm1.delrow_btnClick(Sender: TObject);
var i:integer;
begin
  for i:=data.Row to data.RowCount-2 do
    data.Rows[i].CommaText:=data.Rows[i+1].CommaText;
  data.Rows[data.RowCount-1].CommaText:='';
  data.RowCount:=data.RowCount-1;
end;

procedure TForm1.inscol_btnClick(Sender: TObject);
var j:integer;
begin
  data.ColCount:=data.ColCount+1;
  for j:=data.ColCount-1 downto data.Col+1 do
    data.Cols[j].CommaText:=data.Cols[j-1].CommaText;
  data.Cols[data.Col].CommaText:='';
end;

procedure TForm1.delcol_btnClick(Sender: TObject);
var j:integer;
begin
  for j:=data.Col to data.ColCount-2 do
    data.Cols[j].CommaText:=data.Cols[j+1].CommaText;
  data.Cols[data.ColCount-1].CommaText:='';
  data.ColCount:=data.ColCount-1;
end;

procedure TForm1.dataKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (ssAlt in Shift) and (ssShift in Shift) then
    case Key of
      VK_UP:
        begin
          data.Rows[data.RowCount-1].CommaText:='';
          data.RowCount:=data.RowCount-1;
        end;
      VK_DOWN:
        begin
          data.RowCount:=data.RowCount+1;
        end;
      VK_LEFT:
        begin
          data.Cols[data.ColCount-1].CommaText:='';
          data.ColCount:=data.ColCount-1;
        end;
      VK_RIGHT:
        begin
          data.ColCount:=data.ColCount+1;
        end;
    end;
end;

procedure TForm1.Splitter1Moved(Sender: TObject);
begin
  FormResize(self);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  insrow_btn.Left:=Panel2.Left+2;
  delrow_btn.Left:=insrow_btn.Left+insrow_btn.Width;
  inscol_btn.Left:=delrow_btn.Left+delrow_btn.Width;
  delcol_btn.Left:=inscol_btn.Left+inscol_btn.Width;
  save_btn.Left:=ToolBar.Width-save_btn.Width-2;
  load_btn.Left:=save_btn.Left-load_btn.Width;
end;

initialization
  ForceCurrentDirectory:=true;

end.
